From 89801b34cadcf27e568f974ab6aa4de851a486d5 Mon Sep 17 00:00:00 2001
From: Paul Menzel <paulepanter@users.sourceforge.net>
Date: Fri, 13 Aug 2010 19:07:44 +0200
Subject: [PATCH 2/6] c-l-beginner.tex: Typos, typography, formulations and additions.
MIME-Version: 1.0
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: 8bit

1. I cannot test my changes since my ConTeXt environment is too old.
2. I am not a native English speaker. So please review my corrections.
3. Use correct apostrophee ’ and ellipse ….
4. Added example text to `\ps{}`, `\encl{}` and `\cc{}`.

Signed-off-by: Paul Menzel <paulepanter@users.sourceforge.net>
---
 correspondence-letter-beginner.tex |   82 ++++++++++++++++++------------------
 1 files changed, 41 insertions(+), 41 deletions(-)

diff --git a/correspondence-letter-beginner.tex b/correspondence-letter-beginner.tex
index 6854591..05925b0 100644
--- a/correspondence-letter-beginner.tex
+++ b/correspondence-letter-beginner.tex
@@ -2,11 +2,11 @@
 
 \environment correspondence-environment
 
-\chapter{Beginners guide}
+\chapter{Beginners’ guide}
 
-The most important in the module for the users is the interface to write the letter text and to set the values for one or more letters.
+The most important thing in the module for the users is the interface to write the letter text and to set the values for one or more letters.
 
-You will learn how to write a letter with the module step by step, beginning with just a few lines of text, following with opening and closing sentences and at the end after you know how to set every kind of information you will finally learn how to change the position of the reference line and how to change the texts for the labels and to customise their style and color.
+You will learn how to write a letter with the module step by step, beginning with just a few lines of text, following with opening and closing sentences and at the end, after you know how to set every kind of information, you will finally learn how to change the position of the reference line and how to change the texts for the labels and to customise their style and color.
 
 \startbuffer[interface:text]
 \startletter
@@ -24,7 +24,7 @@ You will learn how to write a letter with the module step by step, beginning wit
 
 \section{Pure text}
 
-To understand how a letter is written let's study the code for the example letter on the left page.
+To understand how a letter is written let’s study the code for the example letter on the left page.
 
 \starttyping
 \usemodule[letter]
@@ -38,13 +38,13 @@ Thus, I came to the conclusion ...
 \stoptext
 \stoptyping
 
-As you could see from the first line the letter module has to be loaded before it could used because it is none of the functions \CONTEXT\ provides by default, to make the examples in the following sections a little bit shorter I will no longer add \type{\usemodule}, \type{\starttext} and \type{\stoptext} but you shouldn't forgot to add all of them in your files.
+As you can see from the first line the letter module has to be loaded before it can be used because it is none of the functions \CONTEXT\ provides by default. To make the examples in the following sections a little bit shorter I will no longer add \type{\usemodule}, \type{\starttext} and \type{\stoptext} but you shouldn’t forget to add all of them in your files.
 
-The content for your letter is written between the letter environment, it doesn't matter if you use blank lines before and after the letter text.
+The content for your letter is written between the letter environment, it doesn’t matter if you use blank lines before or after the letter text.
 
-If you take a closer look at the result on the left side you could see the paragraphs are separated by blank lines, this could be changed with the \type{\setupletterstyle} command but let us keep this for later.
+If you take a closer look at the result on the left side you can see the paragraphs are separated by blank lines. This can be changed with the \type{\setupletterstyle} command but let us keep this for later.
 
-You're not restricted to only one letter in file, it is possible to write as many as you like in a file and you could use this to write serial letters but a easier method to do this is described later in the manual.
+You’re not restricted to only one letter for a file. It is possible to write as many as you like in a file and you could use this to write serial letters. An easier method for this task is described later in this manual.
 
 \startbuffer[interface:opening]
 
@@ -66,11 +66,11 @@ You're not restricted to only one letter in file, it is possible to write as man
 
 \section{Opening and closing}\index{opening}\index{closing}
 
-You saw in the last example how to write a simple text but shouldn't it be possible to give a few opening and also closing words for the letter, because the reader should know for whom the content is.
+You saw in the last example how to write a simple text. But shouldn’t it be possible to give a few opening and also closing words for the letter, because the reader should know for whom the content is.
 
 To achieve this the module provides the two variables {\em opening} and {\em closing}. To feed them with text you could either use the optional arguments for \type{\startletter} as done in the current example or you could set them before the start of the letter with the two commands \type{\setupletter} and \type{\setlettervalue}.
 
-Let us begin with first alternative and set them as argument with \type{\startletter}:
+Let us begin with first alternative and set them as arguments for \type{\startletter}:
 
 \starttyping
 \startletter
@@ -80,7 +80,7 @@ Thus, I came to the conclusion ...
 \stopletter
 \stoptyping
 
-If you don't like this method you could set the two value before the letter environment with the \type{\setupletter} command, the text in your file should now look like:
+If you don’t like this method you could set the two values before the letter environment with the \type{\setupletter} command. The text in your file should now look like:
 
 \starttyping
 \setupletter
@@ -100,11 +100,11 @@ The first version with braces for two values has the following look.
 \setlettervalue{closing}{Greetings from the Author}
 \stoptyping
 
-The values itself had to be given before the letter environment because values in the letter text are ignored and will never be shown in the output.
+The values itself have to be given before the letter environment because values in the letter text are ignored and will never be shown in the output.
 
-You have also to be careful with the content for the values because commas are interpreted as end of the value if you write it as argument for \type{\startletter} or with \type{\setupletter} and the text has to be protected with braces in this case but you don't need them when there is no comma in the argument.
+You have also to be careful with the content for the values because commas are interpreted as end of the value if you write it as argument for \type{\startletter} or with \type{\setupletter} and the text has to be protected with braces in this case but you don’t need them when there is no comma in the argument.
 
-This could not happen if you set the values with the \type{\setlettervalue} command because the content is delimited by the braces and commas are just normal text.
+This cannot happen if you set the values with the \type{\setlettervalue} command, because the content is delimited by the braces and commas are just normal text.
 
 \page[left]
 
@@ -127,9 +127,9 @@ This could not happen if you set the values with the \type{\setlettervalue} comm
 
 \section{Subject}\index{subject}
 
-After you read how to write the text and set values for the opening and closing we mention now how we could write a subject.
+After you read how to write the text and set values for the opening and closing we mention now how we can write a subject.
 
-Instead of integrating this point in the last section I wrote a new to let you understand the system. Before I will tell more let's take a look at the code.
+Instead of integrating this point in the last section I wrote a new one to let you understand the system. Before I will tell more let’s take a look at the code.
 
 \starttyping
 \startletter
@@ -142,7 +142,7 @@ Thus, I came to the conclusion ...
 
 The text for the subject is written as argument for {\em subject} as argument for \type{\startletter}, as you already guess you could have set it also with \type{\setupletter} or \type{\setlettervalue} and this is also possible and true for the values in the following sections.
 
-Besides the {\em subject} you have also the option to set a {\em title} for the letter, the is no big difference between them but the title is normally written before the subject and has and use a slightly bigger size or is emphasized in another way.
+Besides the {\em subject} you have also the option to set a {\em title} for the letter. There is no big difference between them, but the title is normally written before the subject and has a slightly bigger size or is emphasized in another way.
 
 \startbuffer[interface:address]
 
@@ -164,7 +164,7 @@ Besides the {\em subject} you have also the option to set a {\em title} for the
 
 \section{Address}\flushatnextpar{\index{toname}\index{toaddress}}
 
-Letter are normally meant to be send by post and to prevent you from writing the address by hand on the envelope you could buy envelopes with windows. To use these envelopes the address has to be written on the letter and to do this you have to set the {\em name} and the {\em address} for the addressee with the two values {\em toname} and {\em toaddress}.
+Letters are normally meant to be sent by mail. To prevent you from writing the address by hand on the envelope you could buy envelopes with windows. To use these envelopes the address has to be written on the letter and to do this you have to set the {\em name} and the {\em address} for the addressee with the two values {\em toname} and {\em toaddress}.
 
 The input for the example on the left page looks like:
 
@@ -181,7 +181,7 @@ Thus, I came to the conclusion ...
 \stopletter
 \stoptyping
 
-The author prefer to set the values for the addressee not with \type{\startletter} but with \type{\setupletter} but this is just a matter of style and you could select what fits best to your own working style.
+The author prefers to set the values for the addressee not with \type{\startletter} but with \type{\setupletter} but this is just a matter of taste and you can select what fits your own working style best.
 
 \startbuffer[interface:sender]
 
@@ -201,11 +201,11 @@ The author prefer to set the values for the addressee not with \type{\startlette
 
 \section{Sender}\index{fromname}\index{fromaddress}
 
-It is not often enough to have just the addressee information on the letter, you're looking also for way to put the {\em name} and {\em address} for the sender into the header.
+It is not often enough to have just the addressee information on the letter. You’re also looking for a way to put the {\em name} and {\em address} of the sender into the header.
 
-If you have wondered why the author hasn't just used {\em name} and {\em address} as keys for the addressee values you will now find the solution. To make the system consistent to set the values for addressee and the sender both needed key names to prevent confusions which value should use the the simpler and which one a more verbose one both got e prefix to the key to differentiate them, so got addressee information the prefix {\em to} and sender information the prefix {\em from}.
+If you have wondered why the author hasn’t just used {\em name} and {\em address} as keys for the addressee values you will now find the solution. To make the system consistent to set the values for addressee and the sender both needed unique key names to prevent confusion. Which value should use the simpler and which one a more verbose one both got a prefix to the key to differentiate them. So addressee information got the prefix {\em to} and sender information the prefix {\em from}.
 
-The additional input for the example on the left page to the one from the previous examples is:
+The additional lines for the example on the left page compared to the previous one are:
 
 \starttyping
 \setupletter
@@ -213,7 +213,7 @@ The additional input for the example on the left page to the one from the previo
    fromaddress={Hidden Street 2\\57895 Mystery town}]
 \stoptyping
 
-The manual will describe in a later section how to write a own header with a personal look and feel but this is outside of the user interface and requires knowledge about the layout.
+This manual describes in a later section how to write an own header with a personal look and feel. But this is outside of the user interface and requires knowledge about the layout.
 
 \startbuffer[interface:reference]
 
@@ -237,9 +237,9 @@ The manual will describe in a later section how to write a own header with a per
 
 \section{Reference line}
 
-If you're in a company or a organisation you need sometimes a few extra information on your letter. The reference line or block is the right place where you can place these information.
+If you’re in a company or an organisation you sometimes need a few extra information on your letter. The reference line or block is the right place to put these information to.
 
-Our old example from the last section was now extended by a reference line between the information from our addressee and the subject line, the information for the four fields were set with the following code.
+Our old example from the last section is now extended by a reference line between the information of our addressee and the subject line. The information for the four fields are set with the following code.
 
 \starttyping
 \setupletter
@@ -252,9 +252,9 @@ Our old example from the last section was now extended by a reference line betwe
   [list={name,phone,fax,date}]
 \stoptyping
 
-The first \type{\setupletter} set the content for the four fields {\em name}, {\em phone}, {\em fax} and {\em date}. Although the values are set none of them will appear in the output but we have to declare the fields for the reference line first, this is done in the second \type{\setupletter} command with the key {\em list}, the entries will appear in the in the same order as you write them in the list, if one or more of the keys in the list have no values they will still appear in the output but no content is shown.
+The first \type{\setupletter} set the content for the four fields {\em name}, {\em phone}, {\em fax} and {\em date}. Although the values are set none of them will appear in the output. We have to declare the fields for the reference line first, this is done in the second \type{\setupletter} command with the key {\em list}, the entries appear in the same order as you write them in the list. If one or more of the keys in the list have no values they will still appear in the output but no content is shown.
 
-If you change the content for the {\em list} key in your file the module will show by default the date of the current date at the right side of the reference line, this will normally always happen and you could say the result in the examples of the two preceding sections.
+If you do not change the {\em list} key in your file, by default the module will show the current date at the right side of the reference line. This will normally always happen and you could see the result in the examples of the two preceding sections.
 
 \startbuffer[interface:signature]
 
@@ -273,25 +273,25 @@ If you change the content for the {\em list} key in your file the module will sh
 
 \section{Signature}\index{signature}
 
-You know now ho to set the letter text, the opening and closing lines, the values for the addressee and the sender and also how define your own values for the reference line.
+You know now how to set the letter text, the opening and closing lines, the values for the addressee and the sender and also how define your own values for the reference line.
 
-Most of the things need for a letter are already told but a few fields at the end of the letter remains untold, the first line you will add to our example letter is the signature. It is set with the {\em signature} in se same way as the other values in the former examples. What the author did in the left example was:
+Most of the things needed for a letter are already told but a few fields at the end of the letter remain untold. The first line you want to add to our example letter is the signature. It is set with the {\em signature} in the same way as the other values in the former examples. What the author did in the left example was:
 
 \starttyping
 \setupletter
   [signature={Arthur Thor}]
 \stoptyping
 
-There is some space between the closing and the signature to give you the possibility to sign the letter also by hand after you have printed the letter.
+There is some space between the closing and the signature to give you the possibility to sign the letter after having printed it out.
 
-You're not limited to simple text for the signature, it is also possible to use a graphic if you won't sign the letter by hand after you printed it, such a solution would have been for the author the next code.
+You’re not limited to simple text for the signature. It is also possible to use a graphic if you won’t sign the letter by hand after you printed it. This solution is used in the following code.
 
 \starttyping
 \setupletter
   [signature={\externalfigure[autograph][height=2\lineheight]}]
 \stoptyping
 
-How to adjust the space between the closing line and the signature for this way will be shown in the letter style section.
+How to adjust the space between the closing line and the signature for this way is shown in the letter style section.
 
 \start
 
@@ -330,9 +330,9 @@ How to adjust the space between the closing line and the signature for this way
 \starttyping
 \startletter
 
-...
+…
 
-\ps{...}
+\ps{Postscript}
 
 \stopletter
 \stoptyping
@@ -376,10 +376,10 @@ How to adjust the space between the closing line and the signature for this way
 \starttyping
 \startletter
 
-...
+…
 
-\ps{...}
-\encl{...}
+\ps{Postscript}
+\encl{Appendices}
 
 \stopletter
 \stoptyping
@@ -425,11 +425,11 @@ How to adjust the space between the closing line and the signature for this way
 \starttyping
 \startletter
 
-...
+…
 
-\ps{...}
-\encl{...}
-\cc{...}
+\ps{Postscript}
+\encl{Appendices}
+\cc{List of recipients}
 
 \stopletter
 \stoptyping
-- 
1.7.1